/************************************************************************
  This is the include file for the DOS fitting program

   Created by greg Landrum March 1994
************************************************************************/
#include <stdio.h>
#include <math.h>

/******
  These are used by the fileio routines.
*******/
#define FATAL 0
#define ERROR 1
#define IGNORE 2

/********
  The program will compile to use doubles instead of floats to represent everything.
  If for some reason you want to use floats, then you must put -DUSE_FLOATS in the
  CFLAGS field of the makefile
*********/
#ifndef USE_FLOATS
#define float double
#endif


/* this is the step size used to generate the smoothed data (in eV) */
#define ENERGY_STEP .01

/* this is the broadening factor */
#define BROADENING .01


/******
  this is the data type that will be used to store the DOS data
  within the program.
******/
typedef struct{
  float height;
  float energy;
} point_type;
  
